active proctype rand1() {
	int i;
	do
		:: i++;
		:: i--;
		:: break;
	od
	printf("Rand1: %d\n", i);

	run rand2();
}

/**
 * PROBLEM: not verifiable, there exist """infinitely""" many paths of infinite length
 * [to be more precise, since 'i' is bounded the state space is also bounded,
 * but exponentially large and thus intractable]
 */

proctype rand2() {
	int i;
	do
		:: (i >= -10 && i <= 10) ->
			if
				:: i++;
				:: i--;
			fi
		:: break;
	od
	printf("Rand2: %d\n", i);

	run rand3();
}

/**
 * PROBLEM: the numbers don't have the same probability of being generated
 */

proctype rand3() {
	int i;
	if
		:: i = -3;
		:: i = -2;
		:: i = -1;
		:: i = 0;
		:: i = 1;
		:: i = 2;
		:: i = 3;
	fi
	printf("Rand3: %d\n", i);
}

/**
 * perfect solution
 */
